
#include "stdafx.h"
#include "NetClientDemo.h"
#include "AdvLocalSet.h"
#include "../Common/Ini.h"

// CLS_AdvLocalSet Ի

IMPLEMENT_DYNAMIC(CLS_AdvLocalSet, CDialog)

CLS_AdvLocalSet::CLS_AdvLocalSet(CWnd* pParent /*=NULL*/)
	: CLS_BasePage(CLS_AdvLocalSet::IDD, pParent)
{
	m_iLogonID = -1;
	m_iChannelNo = 0;
}

CLS_AdvLocalSet::~CLS_AdvLocalSet()
{
}

void CLS_AdvLocalSet::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CBO_LOGON_MODE, m_cboLogonMode);
	DDX_Control(pDX, IDC_COMBO_USE_RULE, m_cboDemoUseRule);
}


BEGIN_MESSAGE_MAP(CLS_AdvLocalSet, CDialog)
	ON_BN_CLICKED(IDC_BTN_LOGON_MODE, &CLS_AdvLocalSet::OnBnClickedBtnLogonMode)
	ON_WM_SHOWWINDOW()
	ON_BN_CLICKED(IDC_BUTTON_SET_DEMO_USE_RULE, &CLS_AdvLocalSet::OnBnClickedButtonSetDemoUseRule)
END_MESSAGE_MAP()


BOOL CLS_AdvLocalSet::OnInitDialog()
{
	CLS_BasePage::OnInitDialog();

	UI_UpdateDialog();

	LoadSdkWorkMode();

	LoadDemoUseRule();

	return TRUE;
}

void CLS_AdvLocalSet::OnShowWindow(BOOL bShow, UINT nStatus)
{
	CLS_BasePage::OnShowWindow(bShow, nStatus);
}

void CLS_AdvLocalSet::OnLanguageChanged( int _iLanguage)
{
	UI_UpdateDialog();
}

void CLS_AdvLocalSet::OnChannelChanged( int _iLogonID,int _iChannelNo,int _iStreamNo)
{
	m_iLogonID = _iLogonID;
	m_iChannelNo = _iChannelNo;
}

void CLS_AdvLocalSet::UI_UpdateDialog()
{
	SetDlgItemTextEx(IDC_STC_LOGON_MODE, IDS_CFG_ADV_LOGON_MODE);
	SetDlgItemTextEx(IDC_BTN_LOGON_MODE, IDS_SET);

	SetDlgItemTextEx(IDC_STC_MODE_RESART_TIP, IDS_ADVANCE_LOCAL_HINT);
	SetDlgItemTextEx(IDC_STATIC_USE_RULE, IDS_ADVANCE_LOCAL_USE_METHOD);
	SetDlgItemTextEx(IDC_BUTTON_SET_DEMO_USE_RULE, IDS_SET);

	InsertString(m_cboLogonMode, 0, IDS_CFG_ADV_LOGON_HEAVY);
	m_cboLogonMode.SetItemData(0, HEAVY_MODE);
	InsertString(m_cboLogonMode, 1, IDS_CFG_ADV_LOGON_LIGHT);
	m_cboLogonMode.SetItemData(1, LIGHT_MODE);
	InsertString(m_cboLogonMode, 2, IDS_CFG_ADV_LOGON_EASYX_LIGHT);
	m_cboLogonMode.SetItemData(2, EASYX_LIGHT_MODE);	
	InsertString(m_cboLogonMode, 3, IDS_CFG_ADV_LOGON_MOBILE_LIGHT);
	m_cboLogonMode.SetItemData(3, MOBILE_LIGHT_MODE);	

	InsertString(m_cboDemoUseRule, 0, IDS_DEMO_USE_NORMAL);
	m_cboDemoUseRule.SetItemData(0, NORMAL_USE);
	InsertString(m_cboDemoUseRule, 1, IDS_DEMO_USE_RIVER);
	m_cboDemoUseRule.SetItemData(1, RIVER_USE);	
}

void CLS_AdvLocalSet::LoadSdkWorkMode()
{
	CString szNewFile = GetLocalSaveDirectory() + "\\SDKWorkMode.ini";
	CIniFile cFile(szNewFile);

	CString szSection = "WorkMode";
	CString szKey = "Mode";
	int iSDKWorkMode = cFile.ReadInteger((char *)(LPCTSTR)szSection, (char *)(LPCTSTR)szKey, 0);

	m_cboLogonMode.SetCurSel(iSDKWorkMode);
}

void CLS_AdvLocalSet::OnBnClickedBtnLogonMode()
{
	DWORD_PTR iSdkWorkMode = m_cboLogonMode.GetItemData(m_cboLogonMode.GetCurSel());

	//浽ļУʱȡЧ
	CString szNewFile = GetLocalSaveDirectory() + "\\SDKWorkMode.ini";
	CIniFile cFile(szNewFile);
	cFile.ResetFile();	//´ļ

	CString szSection = "WorkMode";
	CString szKey = "Mode";
	
	cFile.WriteInteger((char *)(LPCTSTR)szSection, (char *)(LPCTSTR)szKey, (int)iSdkWorkMode);	
}

void CLS_AdvLocalSet::LoadDemoUseRule()
{
	CString szNewFile = GetLocalSaveDirectory() + "\\DemoUseRule.ini";
	CIniFile cFile(szNewFile);

	CString szSection = "UseRule";
	CString szKey = "Rule";
	int iUseRule = cFile.ReadInteger((char *)(LPCTSTR)szSection, (char *)(LPCTSTR)szKey, 0);

	m_cboDemoUseRule.SetCurSel(iUseRule);
}

void CLS_AdvLocalSet::OnBnClickedButtonSetDemoUseRule()
{
	int iUseRule = (int)m_cboDemoUseRule.GetItemData(m_cboDemoUseRule.GetCurSel());
	CString szNewFile = GetLocalSaveDirectory() + "\\DemoUseRule.ini";
	CIniFile cFile(szNewFile);
	cFile.ResetFile();	//´ļ

	CString szSection = "UseRule";
	CString szKey = "Rule";

	cFile.WriteInteger((char *)(LPCTSTR)szSection, (char *)(LPCTSTR)szKey, iUseRule);	
}
