
#ifndef PUBLICDEF_H
#define PUBLICDEF_H

#include "GlobalTypes.h"

#if (!defined(_WIN32) && !defined(_WIN64))
#include "util_type.h"
#ifndef __cdecl
#define __cdecl		/**<  */
#endif
#ifndef __stdcall
#define __stdcall	/**<  */
#endif
#endif

/*********************************************************************************************/
#define CALLING_CONVENTION			__cdecl
#define MAX_PLAYER_NUM				128/*64*/
#define MAX_SYC_GROUP_NUM			4				//ͬط
#define MAX_SYC_PLAYER_NUM			4				//ͬطplayer
#define MSG_PLAYSDKM4				(WM_USER+0x01FF)//طϢĬֵ
/*********************************************************************************************/


/**********************************************************************************************
* ܺ궨                                                                 
**********************************************************************************************/
#define	SAFE_CLOSE_THREAD(x) if (NULL != (x))	{WaitForSingleObject((x),INFINITE); CloseHandle((x)); (x) = NULL;}
#define	SAFE_CLOSE_HANDLE(x) if (NULL != (x))	{CloseHandle((x)); (x) = NULL;}
#define SAFE_DELETE(x)	if ((x) != NULL)	{delete (x); (x) = NULL;}
#define SAFE_FREE(x)	if ((x) != NULL)	{free((x)); (x) = NULL;}
#define SAFE_DELETE_ARRAY(x)	if ((x) != NULL)	{delete [] (x); (x) = NULL;}
#define SAFE_CLOSE_FILE(x) if ((x) != NULL)	{fclose((x)); (x) = NULL;}
/*********************************************************************************************/



/**********************************************************************************************
* Number of Show Video                                                                   
**********************************************************************************************/
#define	MAX_DRAW_NUM				8
/*********************************************************************************************/


/**********************************************************************************************
* SDK Return Value                                                                   
**********************************************************************************************/
#define TD_OK						0
#define TD_APPLYMEMORY_FAILED		-5
/*********************************************************************************************/


/**********************************************************************************************
* TC_PutStreamToPlayerֵ˵                                                                   
**********************************************************************************************/
#define	RET_BUFFER_FULL				(-11)	//ûз뻺
#define	RET_BUFFER_WILL_BE_FULL		(-18)	//ݵƵ
#define	RET_BUFFER_WILL_BE_EMPTY	(-19)	//գݵƵ
#define RET_BUFFER_IS_OK			(-20)   //Է
/*********************************************************************************************/


/**********************************************************************************************
* طϢLPARAMȡֵб                                                                     
**********************************************************************************************/
#define LPARAM_FILE_PLAY_END		0		//
#define LPARAM_FILE_SEARCH_END		1		//Ѱҵļĩβ
#define LPARAM_NEED_DECRYPT_KEY		2		//Ҫ
#define LPARAM_DECRYPT_KEY_FAILED	3		//
#define LPARAM_DECRYPT_SUCCESS		4		//ܳɹ
#define LPARAM_STREAM_SEARCH_END	5		//û
#define LPARAM_VOD_STREAM_END		6		//VODļ
/*********************************************************************************************/


/**********************************************************************************************
* Decrypt frame return value                                                                     
**********************************************************************************************/
#define DECRYPT_SUCCESS				0		//ܳɹ
#define DECRYPT_INVALID_PARAM		(-1)	//
#define DECRYPT_KEY_NOT_READY		(-2)	//û趨Կ
#define DECRYPT_FRAME_NOT_ENCRYPT	(-3)	//֡Ǽ֡
#define DECRYPT_FAILED				(-4)	//֡ʧ
/*********************************************************************************************/


/**********************************************************************************************
* Record File                                                                       
**********************************************************************************************/
#define REC_FILE_TYPE_NORMAL		0
#define REC_FILE_TYPE_AVI			1
#define REC_FILE_TYPE_ASF			2
#define REC_FILE_TYPE_AUDIO			3
#define REC_FILE_TYPE_WAV			4
#define REC_FILE_TYPE_MP3			5
/*********************************************************************************************/


/**********************************************************************************************
* Player Control Code Used By TC_PlayerControl                                                             
**********************************************************************************************/
#define CTRL_VOD_SETOVERFLAG			0		//set vod play end flag
#define CTRL_VOD_CLEANBUFF				1		//clean vod buffer
#define CTRL_RESETDECODE				2		//resetdecode clean yuv
#define CTRL_RESVERSE_PLAY				3		//reverse play
#define CTRL_REGIST_USERDATA_NOTIFY		4		//regist usrdata notify
#define CTRL_REGIST_DRAW_NOTIFY			5		//regist draw notify
#define CTRL_REGIST_RAW_FRAME_NOTIFY	6		//regist rwa frame notify
/*********************************************************************************************/

//CTRL_REGIST_USERDATA_NOTIFY
typedef struct tagUserDataNotify
{
	int iSize;
	DEVUSERDATA_NOTIFY pNotifyFun;
	void* pvUdata;
}UserDataNotify;


typedef struct tagDrawParam
{
	HDC hDrawDc;
	unsigned int iTimeStamp;
}DrawParam;
typedef void (*DRAW_NOTIFY_V4)(unsigned int _ulID, DrawParam* _ptDrawParam,  void* _iUser);

//CTRL_REGIST_DRAW_NOTIFY
typedef struct tagDrawNotify
{
	int iSize;
	DRAW_NOTIFY_V4 pNotifyFun;
	void* pvUdata;
}DrawNotify;
/**********************************************************************************************
* Audio type                                                                      
**********************************************************************************************/
#define T_AUDIO8					0
#define T_YUV420					1
#define T_YUV422					2
/*********************************************************************************************/


/**********************************************************************************************
* Play Mode                                                                      
**********************************************************************************************/
#define	PLAYMODE_FILE				0		//ļģʽ
#define	PLAYMODE_VOD_FILE			1		//VODģʽ
#define	PLAYMODE_STREAM				2		//ģʽ
/*********************************************************************************************/


/**********************************************************************************************
* Sleep Time                                                                     
**********************************************************************************************/
#define	SLEEP_1						1		//1
#define	SLEEP_100					100		//100
/*********************************************************************************************/


/**********************************************************************************************
* ֵ뺬                                                                        
**********************************************************************************************/
#define RET_INVALID_PLAYERID		-1		//ǷPLAYER ID
#define RET_ERR_PLAYMODE			-2		//Ĳģʽ
#define RET_INVALID_PARAM			-3		//Ƿ
/*********************************************************************************************/


/**********************************************************************************************
* ˢ¹ܿ                                                                        
**********************************************************************************************/
#define CTRL_REFRESHPLAYER			0		//ʼPLAYERΪɫ

#define PLAY_SPEED_VALUE_1			1		//2ٶֵ
#define PLAY_SPEED_VALUE_2			2		//4ٶֵ
#define PLAY_SPEED_VALUE_3			3		//8ٶֵ
#define PLAY_SPEED_VALUE_4			4		//16ٶֵ

#define PLAY_SPEED_2X_RATE			2		//2
#define PLAY_SPEED_4X_RATE			4		//4
#define PLAY_SPEED_8X_RATE			8		//8
#define PLAY_SPEED_16X_RATE			16		//16
/*********************************************************************************************/


/**********************************************************************************************
* Mode Rule                                                                    
**********************************************************************************************/
#define MODERULE_AUTO_ADJUST_DRAW_NO				(0x00)	//Ӧֱͬ--
#define MODERULE_AUTO_ADJUST_DRAW_YES				(0x01)	//Ӧֱͬ--
#define MODERULE_AUTO_ADJUST_STREAM_PLAY_SPEED_YES	(0x11)	//ӦģʽĲ--
#define MODERULE_AUTO_ADJUST_STREAM_PLAY_SPEED_NO	(0x10)	//ӦģʽĲ--
#define MODERULE_STREAM_PLAY_BALANCE				(0x23)	//Ϊģʽ
#define MODERULE_STREAM_PLAY_NO_DELAY				(0x22)	//Ϊʱģʽ
#define MODERULE_STREAM_PLAY_HIGH_SMOOTH			(0x21)	//Ϊģʽ
#define MODERULE_STREAM_PLAY_LOW_DELAY				(0x20)	//Ϊʱģʽ
#define MODERULE_AVIDEO								(0x30)	//ΪƵ
#define MODERULE_PURE_AUDIO							(0x31)	//ΪƵģʽ
#define MODERULE_FAST_FORWARD_SKIP_I				(0x40)	//ΪI֡
#define MODERULE_FAST_FORWARD_NO_SKIP_I				(0x41)	//ΪI֡
#define MODERULE_SINGLE_FILE						(0x50)	//Ϊһļģʽ
#define MODERULE_MUTI_FILE							(0x51)	//Ϊļģʽ
#define MODERULE_FIX_RATIO							(0x60)	//Ƶʾ
#define MODERULE_FIX_WINDOW							(0x61)	//䴰ʾ
#define MODERULE_VIDEO_OPTIMIZE_CLOSE				(0x70)	//ƵЧŻر
#define MODERULE_VIDEO_OPTIMIZE_OPEN				(0x71)	//ƵЧŻ
/*********************************************************************************************/


/*********************************************************************************************/
typedef void (CALLING_CONVENTION* pfCBPlayEnd)(int _iID);
typedef void (CALLING_CONVENTION* pfCBGetDecAV)(int _iID, const DecAVInfo* _pDecAVInfo, void* _iUser);
typedef void (CALLING_CONVENTION* pfCBVideoEdit)(int _iNotifyCode);
typedef int  (CALLING_CONVENTION* pfCBDrawFun)(long _lHandle,HDC _hDc,void* _lUserData);
typedef int  (CALLING_CONVENTION* pfCBDrawFunEx)(long _lHandle,HDC _hDc, long _lWidth, long _lHeight, void* _lUserData);
#ifdef __WIN__
typedef int  (CALLING_CONVENTION* pfCBCommonEventNotify)(int _iPlayerID, int _iEventMessage);
#endif
typedef int  (CALLING_CONVENTION* pfCBCommonEventNotifyEx)(int _iPlayerID, int _iEventMessage, void* _lpUserData);
typedef void (__stdcall* pfAudioCaptureCbk)(unsigned char* _pucData, int _iLen, void* _pvUserData);
typedef void (__stdcall* pfRawFrameCbk)(int _iPlayerID, unsigned char* _pucData, int _iLen, void* _pvUserData);

//ƵɼڶԽ
typedef int (*RECORD_VOICE_NOTIFY)(unsigned char *_pucAuidoBuffer, int _iAudioLen);
/*********************************************************************************************/



//贴ͱ־
typedef enum __tagPlayModeCmd
{
	E_NORMAL_PLAYER		= -1,
	E_FILE_ONLYDECODE	= 0,			//ļģʽ
	E_STREAM_ONLYDECODE	= 1,			//ģʽ
	E_YUV_PLAYER		= 2,			//YUV
	E_RGB_PLAYER		= 3,			//RGB
	E_SYC_PLAYER		= 4,			//ͬ
}PlayModeCmd, *LPPlayModeCmd;



typedef struct tagRECTEx
{
	double		left;					//ԭƵٷֱ
	double		top;					//ԭƵٷֱ
	double		right;					//ԭƵٷֱ
	double		bottom;					//ԭƵٷֱ
}RECTEX, *PRECTEX;


struct FILE_PLAYER
{
	char*		m_pcFileName;			//ļ
	int			m_iDownloadBufSize;		//ػС
	int			m_iFileTrueSize;		//ļС
	int*		m_piNowFileSize;		//ǰļС
	int			m_iLastFrmNo;			//һ֡֡
	int*		m_piCompleteFlag;		//Ƿ
};


struct STREAM_PLAYER
{
	char		m_VideoHeader[88];		//Ƶͷ
	int			m_iStreamBufferSize;	//ƴ֡С 0ΪĬ
};


typedef struct __tagPlayerHeader
{
	int			iSize;
	HWND		hwnd;					//ʾ
	int			iWidth;
	int			iHeight;
} TPlayerHeader, *PTPlayerHeader;

typedef void (CALLING_CONVENTION* FISHEYE_CallBack)(int _iID, int _iSubID, HDC _pvDC, unsigned int _uiWidth, unsigned int _uiHeight, void* _pvUsrData);

//װʽ 
#define FEC_MOUNTING_WALL			1	//װʽˮƽ
#define FEC_MOUNTING_FLOOR			2	//氲װ(ϣ
#define FEC_MOUNTING_CEILING		3	//װʽ(£

//ʽ
#define FEC_CORRECT_PTZ		0x100		//PTZ 
#define FEC_CORRECT_180		0x200		//180Ƚ
#define FEC_CORRECT_360		0x300		//360ȫ
#define FEC_CORRECT_LAT		0x400		//γչ

//۽CMD
#define CMD_CORRECT_PTZPARA				1		//PTZ
#define CMD_CORRECT_CYCLERADIUS			2		//ͼԲĲ,Բ,ֻֻ֧ȡ
#define CMD_CORRECT_WIDESCANOFFSET		3		//180360Ƚ
#define CMD_RESERVE_LAST_FRAME			0XFF	//Ƿһ֡,0-,1-. Ĭϲ,Ƶʾ.

//PTZصӦͼ͵
#define PTZ_RET_TYPE_NONE	 0x0000		//Ҫ㣬ֻͼ
#define PTZ_RET_TYPE_FISH	 0x1000		//PTZصͼ
#define PTZ_RET_TYPE_180	 0x2000		//PTZص180Ƚͼ㣬ݲ֧
#define PTZ_RET_TYPE_360	 0x3000		//PTZص360Ƚͼ
#define PTZ_RET_TYPE_LAT	 0x4000		//PTZصγչͼ
typedef struct tagCorrectPtzPara
{
	int				iSize;
	int				iPtzID;				//Ptzڱ,Χ0-7
	int				iPTZPositionX;		//PTZ ʾλX
	int				iPTZPositionY;		//PTZ ʾλY
	int				iZoom;				//PTZ ʾķΧ
	int				iPTZRstWidth;		//PTZ ͼĿ
	int				iPTZRstHeight;		//PTZ ͼĸ߶
	int				iPTZRetType;		//PTZ صӦͼ
} CorrectPtzPara, *pCorrectPtzPara;

typedef struct tagCorrectCyclePara
{
	int		iSize;					
	int		iRadiusLeft;		//ԲX꣬ʹֱȱʾ
	int		iRadiusRight;		//ԲұX꣬ʹֱȱʾ 
	int		iRadiusTop;			//ԲϱY꣬ʹֱȱʾ
	int		iRadiusBottom;		//Բ±Y꣬ʹֱȱʾ
} CorrectCyclePara, *pCorrectCyclePara;

typedef struct tagCorrectWideScanPara
{
	int		iSize;					
	float   fWideScanOffset;        // 180360УƫƽǶ
} CorrectWideScanPara, *pCorrectWideScanPara;

typedef struct tagCreateCorrectPara
{
	int					iSize;					
	int					iPlaceType;		//װʽ
	int					iCorrectType;	//ʽ
	CorrectCyclePara	tCycleRadius;	//ͼԲĲ
	CorrectWideScanPara	tWideScanPara;	//80360УƫƽǶ
	CorrectPtzPara		tPtzPara;		//PTZ
	HWND				hWnd;			//ʾ
} CreateCorrectPara, *pCreateCorrectPara;

//ץ
#define CAPTURE_PICTURE_TYPE_BMP		1
#define CAPTURE_PICTURE_TYPE_JPG		2 
#define CAPTURE_PICTURE_TYPE_FEC_BMP	3
#define CAPTURE_PICTURE_TYPE_FEC_JPG	4 

#define DEFAULT_CYCLE_RADIUS_LEFT		0
#define DEFAULT_CYCLE_RADIUS_RIGHT		10000
#define DEFAULT_CYCLE_RADIUS_TOP		0
#define DEFAULT_CYCLE_RADIUS_BOTTOM		10000

#define MAX_FEC_TRACK_COUNT		8
#define START_ALL_FEC_TRACK		-1
#define STOP_ALL_FEC_TRACK		-1
typedef struct tagFECTrackInfo
{
	int			iSize;
	int			iWindowCount;						//ҪٵĴĿĿǰ֧8PTZ
	int			iPtzSubID[MAX_FEC_TRACK_COUNT];		//ÿPTZٶӦУIDPTZУʱɽӿTC_CreateFishEyeCorrectصSubID
} FECTrackInfo, *pFECTrackInfo;

#endif
