// console_demo.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <windows.h>
#include "./sdk/NetClientTypes.h"
#include "./sdk/libNVSSDK.h"

HWND g_hMsgForm = NULL;
DWORD  g_dwMsgThread = 0;
HANDLE g_hMsgThread = INVALID_HANDLE_VALUE;

#define MSG_INNER_EVENT WM_USER + 10001

static int g_iLogonID = -1;
static unsigned long g_uiDataID = 0xFFFFFFFF;
static char g_cNVSIP[] = "10.10.62.136";

static bool g_blStartPlay = false;

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{	
	if(MSG_INNER_EVENT == message)
	{
		pNVS_IPAndID  pTem = (pNVS_IPAndID)lParam;
		if(NULL == pTem)
			return 0;

		int iMsgType = LOWORD(wParam);

		if(iMsgType == WCM_LOGON_NOTIFY)
		{
			int iLogonState = HIWORD(wParam);
			if(iLogonState == LOGON_SUCCESS)
			{
				::OutputDebugString("log on ok \r\n");

				CLIENTINFO cltInfo;
				memset(&cltInfo,0,sizeof(CLIENTINFO));

				cltInfo.m_iChannelNo = 0;
				strcpy(cltInfo.m_cRemoteIP,g_cNVSIP);
				cltInfo.m_iNetMode = 1;
				cltInfo.m_iTimeout = 2000;
				cltInfo.m_iTTL = 8;
				cltInfo.m_iBufferCount = 5;
				cltInfo.m_iDelayNum = 1;
				cltInfo.m_iStreamNO = 0;
				cltInfo.m_iServerID = g_iLogonID;

				int iRet = NetClient_StartRecv(&g_uiDataID,&cltInfo,NULL);
				if(0 != iRet)
				{
					::OutputDebugString("NetClient_StartRecv failed");
					return FALSE;
				}
			}
			else
			{
				
			}		
		}
		else if(iMsgType == WCM_VIDEO_HEAD)
		{
			::OutputDebugString("receive stream head \r\n");

			RECT rtPlay;
			GetWindowRect(g_hMsgForm,&rtPlay);
			int iRet = NetClient_StartPlay(g_uiDataID,g_hMsgForm,rtPlay,0);
			if(0 != iRet)
			{
				::OutputDebugString("play failed \r\n");
			}
			g_blStartPlay = true;
			
		}

	}
	return DefWindowProc(hWnd, message, wParam, lParam); 
}

DWORD WINAPI MsgThread(void* _para)
{
	char szWindowClass[] = "INNER_FORM";
	char szTitle[] = "MSG_FORM";

	HINSTANCE hInstance = GetModuleHandle(NULL);//::AfxGetInstanceHandle();

	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= NULL;
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= NULL;

	int iRet =  RegisterClassEx(&wcex);

	DWORD dwError = ::GetLastError();

	g_hMsgForm = CreateWindow(szWindowClass, szTitle, WS_BORDER,// | WS_VISIBLE ,  //ѴʾԼWS_VISIBLE
		10, 10, 100, 100, NULL, NULL, hInstance, NULL);

	dwError = ::GetLastError();

	MSG msg;
	HACCEL hAccelTable = NULL;
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}


	return (int) msg.wParam;
}

int _tmain(int argc, _TCHAR* argv[])
{
	g_hMsgThread =  CreateThread(NULL,0,MsgThread,NULL,0,&g_dwMsgThread);       //
	while(NULL == g_hMsgForm)
	{
		Sleep(10);            //ȴ߳Ҳͨʽʵ
	}

	int iRet = LoadNVSSDK();
	if(0 != iRet)
		return -1;

	NetClient_SetPort(3000,6000);//ʼNVSSDK
	NetClient_SetMSGHandle(MSG_INNER_EVENT,g_hMsgForm,0,0);       //עϢ
	NetClient_Startup();

	g_iLogonID = NetClient_Logon(NULL,g_cNVSIP,"Admin","Admin",NULL,3000);

	bool blCapture = false;  //ֻץһͼƬ
	while(1)
	{
		Sleep(1);
		if(true == g_blStartPlay && false == blCapture)
		{
			int iPlayStatus = NetClient_GetPlayingStatus(g_uiDataID);	
			if(iPlayStatus == PLAYER_PLAYING)  //ҪȿʼԺ󣬲ܽץͼ
			{
				Sleep(1000);
				int iSize = NetClient_CaptureBmpPic(g_uiDataID,"c:\\test_1.bmp");
				if(iSize < 0)
				{
					::OutputDebugString("capture bmp failed \r\n");
				}
				else
				{
					::OutputDebugString("capture bmp ok \r\n");
					blCapture = true;
				}
			}
			
		}
	}

	return 0;
}

