#ifndef NETCLIENTTYPES_H
#define NETCLIENTTYPES_H

typedef int				TD_SOCKET;

typedef unsigned char   TD_U8;
typedef unsigned char   TD_UCHAR;
typedef unsigned short  TD_U16;
typedef unsigned int    TD_U32;
typedef signed char     TD_S8;
typedef signed short    TD_S16;
typedef signed int      TD_S32;
typedef char            TD_CHAR;
typedef char*           TD_PCHAR;
typedef float           TD_FLOAT;
typedef double          TD_DOUBLE;
typedef void            TD_VOID;
typedef void*			TD_HDL;
typedef void*			TD_HANDLE;

// typedef enum 
// {
//     TD_FALSE = 0,
//     TD_TRUE  = 1,
// } TD_BOOL;

typedef int				TD_BOOL;
#define TD_FALSE		0
#define TD_TRUE			1

#define TD_NULL                 0L
#define TD_NULL_PTR             TD_NULL

#define TD_SUCCESS              0
#define TD_FAILURE              (-1)

#define  TD_LITTLE_ENDIAN       1234      
#define  TD_BIG_ENDIAN          4321      


#ifdef _MSC_VER
typedef __int64                 TD_S64;
typedef unsigned __int64        TD_U64;
#endif

#if defined __INTEL_COMPILER || defined __GNUC__
typedef long long               TD_S64;
typedef unsigned long long      TD_U64;
#endif

#define MAX_CHANNEL_TYPE    2
#define	MAX_CHANNEL_NUM		32	//֧3511
#define MAX_CONNECTION		16
#define MAX_PORT_NUM        16
#define MAX_DOWNLOAD_NUM    5
#define MAX_COM_NUM			16	//󴮿

#define MAX_RECV_CHANNEL    1024
#define MAX_ENCODER         1024

#define LENGTH_USER_NAME	16
#define LENGTH_PASSWORD		16
#define LENGTH_CHN_TITLE    32
#define LENGTH_DEVICE_NAME  32
#define LENGTH_IPV4			16	

//connect mode
#define NETMODE_TCP     1   //Tcp connect
#define NETMODE_UDP     2   //Udp connect
#define NETMODE_MC      3   //Multicast connect
#define NVS_ACTIVE      4   //Positive Mode
#define NETMODE_P2P		5   //P2P connect

//Video resolution
#define QCIF	0   //Quarter Cif 	172*144
#define HCIF	1   //Half Cif	352*144	
#define FCIF	2	//Full Cif	352*288	
#define HD1	    3	//Half D1	720*288
#define FD1	    4	//Full D1	720*576
#define QVGA    6   //QVGA      320x240
#define VGA     7   //VGA       720*567
#define HVGA	8	//HVGA      640*240
#define HD_720P 9   //720p      1280*720

//Stream type
#define MAIN_STREAM   0           //Basic stream(hight quality)
#define SUB_STREAM    1           //Extended stream(low bitrate)

//Device type
#define NVS_T       0           //T serials NVS
#define NVS_S       1           //S serials NVS
#define NVS_TPLUS   2           //T+ serials NVS

//Product Model
#define PRODUCT_MODEL_S2_NS_1			0x0060
#define PRODUCT_MODEL_S2_NS_2			0x0061
#define PRODUCT_MODEL_S2_NS_4			0x0062

#define PRODUCT_MODEL_355_NC_HD			0x0050
#define PRODUCT_MODEL_S2_NC_HD			0x0051

#define PRODUCT_MODEL_3511_DVR_8		0x0110
#define PRODUCT_MODEL_3511_DVR_16		0x0100

//Encode type
#define H263		11
#define H264		21
#define MP4			31
#define MJPEG		41


//H264 Decod mode
#define H264DEC_DECTWO	0		//decode 2 field
#define H264DEC_DECTOP	1		//decode top field low CPU cost

//Message define
#define WCM_RECVMESSAGE         1   //Received string
#define WCM_ERR_ORDER           2   //Occur error in command socket 
#define WCM_ERR_DATANET         3   //Occur error when connect count over max
#define WCM_TIMEOUT_DATANET     4   //Process stream timeout
#define WCM_ERR_PLAYER          5   //Occur error in player
#define WCM_ERR_USER            6   //User define error
#define WCM_LOGON_NOTIFY        7   //Logon notify
#define WCM_VIDEO_HEAD          8   //Received video head
#define WCM_VIDEO_DISCONNECT    9   //the connection were disconnect by mediacenter

//Message of Mediacenter
#define WCM_CLIENT_CONNECT      10  //There a client connected to Mediacenter
#define WCM_CLIENT_DISCONNECT   11  //A client disconnected from Mediacenter
#define WCM_CLIENT_LOGON        12  //A client logon/logogg the Mediacenter

#define WCM_RECORD_ERR          13  //Occur when recording file

//Directory Service Mode
#define WCM_DSM_REGERR          14  //Error on proxy regist to Directory server
#define WCM_DSM_ENCODERADD      15  //A NVS regist on the proxy
#define WCM_DSM_ENCODERDEL      16  //A NVS's regist connection disconnected.
//#define	WCM_DSM_ENCODERCHANGE	28	// A NVS'S IP changed.

//Message of Download logfile
#define WCM_LOGFILE_FINISHED    17  //When logfile download finished

//Message of query file
#define WCM_QUERYFILE_FINISHED  18  //Query finished record files

#define WCM_DWONLOAD_FINISHED   19  //Download finished
#define WCM_DWONLOAD_FAULT		20  //Download fault
#define WCM_REBUILDINDEX        22  //Finished of rebuild index file

//Message of talk
#define WCM_TALK				23  //Begin to talk

//Message of DiskManager
#define WCM_DISK_FORMAT_PROGRESS	24
#define WCM_DISK_FORMAT_ERROR		25
#define WCM_DISK_PART_ERROR			26

//Message of Backup Kernel
#define	WCM_BUCKUP_KERNEL			27

//Message of LocalstoreClearDisk
#define	WCM_LOCALSTORE_PROGRESS		28

//Number of Show Video
#define MAX_DRAW_NUM	2

//User authority
// enum
// {
//     AUT_BROWSE			   = 1,		//Only can preview video
//     AUT_BROWSE_CTRL		   = 2,		//Can preview and control device
//     AUT_BROWSE_CTRL_SET	   = 3,		//Preview, control device, modify settings
//     AUT_ADMIN			   = 4		//Super user, No.0 user is super user,
// 									//User name is Admin, which can not be modified,
//     								//Can add, delete, modify user's authority
// };

#define AUT_BROWSE				1
#define AUT_BROWSE_CTRL			2
#define AUT_BROWSE_CTRL_SET		3
#define AUT_ADMIN				4

//Alarm type
// enum ALARMTYPE
// {
//     ALARM_VDO_MOTION,       //Video motion alarm
//     ALARM_VDO_REC,          //video mask alarm
//     ALARM_VDO_LOST,         //Video lost alarm
//     ALARM_VDO_INPORT,        //Input port alarm
// 	ALARM_VDO_OUTPORT		//Output port alarm
// };

typedef int						ALARMTYPE;
#define ALARM_VDO_MOTION		0
#define ALARM_VDO_REC			1
#define ALARM_VDO_LOST			2
#define ALARM_VDO_INPORT		3
#define ALARM_VDO_OUTPORT		4

//Logon state
// enum
// {
//     LOGON_DSMING        = 3,    //DSMDirectory Sevices Modeconnecting
//     LOGON_RETRY         = 2,    //Retry
//     LOGON_SUCCESS       = 0,    //Logon successfully
//     LOGON_ING           = 1,    //Being logon
//     LOGON_FAILED        = 4,   //Fail to logon
//     LOGON_TIMEOUT       = 5,   //Logon timeout
//     NOT_LOGON           = 6,   //Not logon
//     LOGON_DSMFAILED     = 7,   //DSM connection failure
//     LOGON_DSMTIMEOUT    = 8    //DSM connection overtime
// };

#define LOGON_DSMING			3
#define LOGON_RETRY				2
#define LOGON_SUCCESS			0
#define LOGON_ING				1
#define LOGON_FAILED			4
#define LOGON_TIMEOUT			5
#define NOT_LOGON				6
#define	LOGON_DSMFAILED			7
#define LOGON_DSMTIMEOUT		8

//Player state
// enum
// {
//     PLAYER_STOP         = 0,    //Not require to play
//     PLAYER_WAITTING     = 0x01, //Require to play but not play, waiting for data
//     PLAYER_PLAYING      = 0x02, //Playing
//     PLAYER_CARDWAITTING = 0x04, //Require to hardware decode
//     PLAYER_CARDPLAYING  = 0x08  //Being hardware decode output
// };

#define	PLAYER_STOP				0
#define PLAYER_WAITTING			0x01
#define PLAYER_PLAYING			0x02
#define PLAYER_CARDWAITTING		0x04
#define PLAYER_CARDPLAYING		0x08


//PAL/NTSC
// enum VIDEO_NORM
// {
//     VIDEO_MODE_PAL    = 0x00,
//     VIDEO_MODE_NTSC   = 0x01,
//     VIDEO_MODE_AUTO   = 0x02
// };

typedef int						VIDEO_NORM;
#define VIDEO_MODE_PAL			0x00
#define VIDEO_MODE_NTSC			0x01
#define VIDEO_MODE_AUTO			0x02

//Character overlay type
// enum
// {
//     OSDTYPE_TIME      = 0x01,   //Overlay time
//     OSDTYPE_TITLE     = 0x02,   //Overlay character string
//     OSDTYPE_LOGO      = 0x04    //Overlay mark
// };

#define OSDTYPE_TIME			0x01
#define OSDTYPE_TITLE			0x02
#define	OSDTYPE_LOGO			0x04

//Image property
// enum
// {
//     BRIGHTNESS = 0,         //Brightness
//     CONTRAST   = 1,         //Contrast
//     SATURATION = 2,         //Saturation
//     HUE        = 3          //Hue
// };

#define BRIGHTNESS				0
#define CONTRAST				1
#define SATURATION				2
#define HUE						3

//Prefer mode
// enum
// {
//     VDOQUALITY = 0,     //Video quality prefer
//     FRAMERATE  = 2      //Framerate prefer
// };

#define VDOQUALITY				0
#define FRAMERATE				2

//Stream encode type
// enum
// {
//     NO_STREAM   = 0,    //Null
//     ONLY_VIDEO  = 1,    //Video stream
//     ONLY_AUDIO  = 2,    //Audio stream
//     VIDEO_AUDIO = 3     //Video and audio stream
// };

#define NO_STREAM				0
#define ONLY_VIDEO				1
#define ONLY_AUDIO				2
#define VIDEO_AUDIO				3

// enum
// {
//     DISABLE     = 0,
//     ENABLE      = 1
// };

#define	DISABLE					0
#define ENABLE					1

// enum
// {
//     LOW         = 0,
//     HIGH        = 1
// };

#define LOW						0
#define HIGH					1

//Talk
// enum
// {
//     TALK_BEGIN_OK       = 0,    //Start talk successfully
//     TALK_BEGIN_ERROR    = 1,   //Fail to start talk
//     TALK_ERROR          = 2,    //Talk error
// 	TALK_END_OK			= 3
// };

#define TALK_BEGIN_OK			0
#define TALK_BEGIN_ERROR		1
#define TALK_ERROR				2
#define TALK_END_OK				3

// enum
// {
// 	TALK_STATE_NO_TALK		= 0,
// 	TALK_STATE_ASK_BEGIN	= 1,
// 	TALK_STATE_TALKING		= 2,
// 	TALK_STATE_ASK_STOP		= 3
// };

#define TALK_STATE_NO_TALK		0
#define TALK_STATE_ASK_BEGIN	1
#define TALK_STATE_TALKING		2
#define TALK_STATE_ASK_STOP		3

//Core remote upgrade
// enum
// {
//     PRO_UPGRADE_OK      = 0,    // Remote upgrade success
//     PRO_UPGRADE_ERROR   = -1    // Remote upgrade failure
// };

#define PRO_UPGRADE_OK			0
#define	PRO_UPGRADE_ERROR		(-1)

// enum
// {
//     WEB_UPGRADE_OK      = 0,    // Remote upgrade success
//     WEB_UPGRADE_ERROR   = -1    // Remote upgrade failure
// };

#define WEB_UPGRADE_OK			0
#define WEB_UPGRADE_ERROR		(-1)

//Ƶ豸
// enum PARATYPE
// {
//     PARA_VIDOEPARA          =0,     //Generate when modify video adjustment (Brightness, contrast, sue, saturation);
//     PARA_VIDEOQUALITY       =1,     //Generate when modify video quality parameter;
//     PARA_FRAMERATE          =2,     //Generate when modify video frame parameter;
//     PARA_IFRAMERATE         =3,     //Generate when modify video key frame;
//     PARA_STREAMTYPE         =4,     //Generate when compressed video stream is changed;
//     PARA_MOTIONDETECTAREA   =5,     //Generate when video motion test area is changed;
//     PARA_THRESHOLD          =6,     //Generate when video motion sensitivity is changed;
//     PARA_MOTIONDETECT       =7,     //Generate when the start of video motion alarm is changed;
//     PARA_OSDTEXT            =8,     //Generate when character overlay property is changed;
//     PARA_OSDTYPE            =9,     //Generate when character overlay type is changed;
//     PARA_ALMINMODE          =10,    //Generate when input port alarm state is changed;
//     PARA_ALMOUTMODE         =11,    //Generate when output port alarm state is changed;
//     PARA_ALARMINPUT         =12,    //Generate when input port triggering relationship is changed;
//     PARA_ALARMOUTPUT        =13,    //Generate when output port triggering relationship is changed;
//     PARA_AlMVDOCOVTHRESHOLD =14,    //Generate when video mask sensitivity is changed, it is not offered temporarily;
//     PARA_ALMVIDEOCOV        =15,    //Generate when video mask alarm state is changed, it is not offered temporarily;
//     PARA_RECORDCOVERAREA    =16,    //Generate when record mask area is changed, it is not offered temporarily;
//     PARA_RECORDCOVER        =17,    //Generate when record mask is changed, it is not offered temporarily;
//     PARA_ALMVDOLOST         =18,    //Generate when video lost state is changed;
//     PARA_DEVICETYPE         =19,    //Generate when camera site type is changed;
//     PARA_NEWIP              =20,    //Notice when device IP address is changed;
//     PARA_AUDIOCHN           =21,    //Generate when audio channel triggering is changed;
//     PARA_IPFILTER           =22,    //Generate when IP address parameter is changed;
//     PARA_COVERAREA          =23,    //Generate when video mask area is changed;
//     PARA_VIDEOHEADER        =24,    //Generate when video head is changed;
//     PARA_VIDEOSIZE          =25,    //Generate when video size is changed;
//     PARA_BITRATE            =26,    //Generate when stream rate parameter is changed;
//     PARA_DATACHANGED		=27,    //Generate when user data is changed;
//     PARA_PARSECHANGED		=28,    //Generate when domain analysis parameter is changed;
// 
//     PARA_APPIFRAMERATE      =29,    //Generate when sub stream key frame rate is changed;
//     PARA_APPFRAMERATE       =30,    //Generate when sub stream frame rate is changed;
//     PARA_APPVIDEOQUALITY    =31,    //Generate when sub stream video quality is changed;
//     PARA_APPVIDEOSIZE       =32,    //Generate when sub stream video size is changed;
//     PARA_APPSTREAMTYPE      =33,    //Generate when sub stream compression type is changed;
//     PARA_APPBITRATE         =34,    //Generate when sub stream rate limit property is changed;
//     PARA_APPCOVERAREA       =35,    //Generate when sub stream video mask property is changed;
//     PARA_APPVIDEOHEADER     =36,    //Generate when sub stream video head is changed;
// 
//     PARA_REDUCENOISE        =37,    //Generate when noise reduce state is changed;
//     PARA_BOTHSTREAMSAME     =38,    //Generate when whether main and sub stream property are set same is changed;
//     PARA_PPPOE              =39,    //Generate when PPPoE dial property is changed;
// 
//     PARA_ENCODETYPE         =40,    //Generate when VBR/CBR property is changed;
//     PARA_PREFERMODE         =41,    //Generate when Frame Rate Prefer/Quality Prefer property is changed;
//     
//     PARA_LOGFILE            =42,    //Generate when log property is changed;
//     PARA_SETLOGOOK          =43,    //Generate when succeed to set LOGO overlay (Support T serials only)
// 
//     PARA_STORAGE_SCHEDULE   =44,    //Generate when schedule record plan is changed;
//     PARA_STORAGE_TASKSTATE  =45,    //Generate when schedule record state is changed;
//     PARA_STORAGE_ALARMSTATE =46,    //Generate when alarm record state is changed;
//     PARA_STORAGE_PRERECORD  =47,    //Generate when alarm pre-record parameter is changed;
//     PARA_STORAGE_RECORDRULE =49,    //Generate when record package time, dealing rules when disk is full, or minimum free space is changed;
//     PARA_STORAGE_EXTNAME    =50,    //Generate when record file extended name is changed;
//     PARA_STORAGE_MAPDEVICE  =51,    //Generate when storage device mapping parameter is changed;
//     PARA_STORAGE_MOUNTUSB   =52,    //Generate when USB device state is changed;
//     PARA_STORAGE_DISKSTATE  =53,    //Generate when disk state is changed;
//     PARA_AUDIOCODER         =54,    //Generate when audio encode format is changed;
//     PARA_NPMODE             =55,    //Generate when video format is changed;
//     PARA_STORAGE_RECORDSTATE=56,     //Generate when current record state is changed
// 
//     PARA_PU_MANAGERSVR      =57,    //Generate when Manager server info is changed;
//     PARA_PU_DEVICEID        =58,    //Generate when Device ID is changed;
//     PARA_STREAMCLIENT       =59,    //Generate when Stream client info changed;
//     PARA_DATEFORMAT         =60,    //Generate when Date format is changed;
//     PARA_HTTPPORT           =61,    //Generate when HTTP service port is changed;
// 
//     PARA_CMOS_SCENE         =62,    //Generate when scene is changed;
//     PARA_SMTP_INTO          =63,    //Generate when smtp information is changed;
//     PARA_SMTP_ENABLE        =64,     //Generate when smtp notify enable is changed;
//     PARA_SENSORFLIP         =65,     //Generate when flip enable is changed;
// 
// 	PRAM_WIFI_PARAM         = 66,   //Generate when wifi param changed
//     PARA_WIFI_SEARCH_RESULT = 67,    //Generate when wifi search result arrive
// 	
//     PARA_PRIVACYPROTECT     =68,
//     PARA_NTP                =69,
//     PARA_ALARTHRESHOLD      =70,
//     PARA_OSDALPHA           =71,
// 	PARA_WORDOVERLAY		=72,
// 
// 	PARA_ALARMSERVER		=73,
// 	PARA_DHCP_BACK			=74,
// 	PARA_WIFIDHCP_BACK      =75,
// 	PARA_DIAPHANEITY		=76,
// 	PARA_PTZ_PROTOCOL		=77,
// 	PARA_3D					=78,
// 	PARA_DISK_USAGE			=79,
// 	PARA_VIDEOPARA_SCHEDULE =80,
// 	PARA_ALARM_INPORT		=81,
// 	PARA_ALARM_OUT			=82,
// 	PARA_INPORT_SCHEDULE    =83,
// 	PARA_OUTPORT_SCHEDULE	=84,
// 	PARA_MOTION_SCHEDULE	=85,
// 	PARA_VDOLOST_SCHEDULE	=86,
// 	PARA_VDOLOST_LINKREC	=87,
// 	PARA_MOTIONDEC_LINKREC	=88,
// 	PARA_ALMINPORT_LINKREC	=89,
// 	PARA_VDOLOST_LINKSNAP	=90,
// 	PARA_MOTIONDEC_LINKSNAP	=91,
// 	PARA_ALMINPORT_LINKSNAP =92,
// 	PARA_VDOLOST_LINKPTZ	=93,
// 	PARA_ALMINPORT_LINKPTZ	=94,
// 	PARA_VDOLOST_LINKSNDDIS	=95,
// 	PARA_MOTIONDEC_LNKSNDDIS=96,
// 	PARA_ALMINPORT_LNKSNDDIS=97,
// 	PARA_ALMINPORT_LNKOUT   =98,
// 	PARA_VDOLOST_LNKOUT		=99,
// 	PARA_MOTIONDEC_LNKOUT	=100,
// 	PARA_OUTPORT_DELAY		=101,
// 	PARA_UPNP_ENABLE		=102,
// 	PARA_SYSINFO_RESULT		=103,
// 	PARA_DDNSCHANGED 		=104,	    //Generate when DDNS  parameter is changed;
// 	PARA_FUNCLIST			=105,	
// 	PARA_OUTPORT_STATE		=106,
// 	PARA_ZTEINFO			=107,
// 	PARA_ONLINESTATE		=108,
//         PARA_DZINFO			=109,
// 	PARA_COMSERVER			=110,
// 	PARA_VENCTYPE			=111,
// 	PARA_PTZAUTOPBACK		=112,
// 	PARA_3GDEVICESTATUS		=113,
// 	PARA_3GDIALOG			=114,
// 	PARA_3GMESSAGE			=115
// };

typedef int							PARATYPE;
#define PARA_VIDOEPARA				0     
#define PARA_VIDEOQUALITY			1     
#define PARA_FRAMERATE				2     
#define PARA_IFRAMERATE				3     
#define PARA_STREAMTYPE				4     
#define PARA_MOTIONDETECTAREA		5
#define PARA_THRESHOLD          	6    
#define PARA_MOTIONDETECT			7     
#define PARA_OSDTEXT				8    
#define PARA_OSDTYPE				9     
#define PARA_ALMINMODE				10    
#define PARA_ALMOUTMODE				11    
#define PARA_ALARMINPUT				12    
#define PARA_ALARMOUTPUT			13    
#define PARA_AlMVDOCOVTHRESHOLD		14    
#define PARA_ALMVIDEOCOV			15    
#define PARA_RECORDCOVERAREA		16    
#define PARA_RECORDCOVER			17    
#define PARA_ALMVDOLOST				18    
#define PARA_DEVICETYPE				19    
#define PARA_NEWIP					20
#define PARA_AUDIOCHN				21    
#define PARA_IPFILTER				22    
#define PARA_COVERAREA				23    
#define PARA_VIDEOHEADER			24
#define PARA_VIDEOSIZE				25    
#define PARA_BITRATE				26    
#define PARA_DATACHANGED			27
#define PARA_PARSECHANGED			28   

#define PARA_APPIFRAMERATE			29    
#define PARA_APPFRAMERATE			30    
#define PARA_APPVIDEOQUALITY		31    
#define PARA_APPVIDEOSIZE			32    
#define PARA_APPSTREAMTYPE			33    
#define PARA_APPBITRATE				34    
#define PARA_APPCOVERAREA			35    
#define PARA_APPVIDEOHEADER			36    

#define PARA_REDUCENOISE			37    
#define PARA_BOTHSTREAMSAME			38    
#define PARA_PPPOE					39    

#define PARA_ENCODETYPE				40    
#define PARA_PREFERMODE				41    

#define PARA_LOGFILE				42    
#define PARA_SETLOGOOK				43    
    
#define PARA_STORAGE_SCHEDULE   	44   
#define PARA_STORAGE_TASKSTATE		45    
#define PARA_STORAGE_ALARMSTATE		46    
#define PARA_STORAGE_PRERECORD		47    
#define PARA_STORAGE_RECORDRULE		49    
#define PARA_STORAGE_EXTNAME		50    
#define PARA_STORAGE_MAPDEVICE		51    
#define PARA_STORAGE_MOUNTUSB		52    
#define PARA_STORAGE_DISKSTATE		53    
#define PARA_AUDIOCODER				54    
#define PARA_NPMODE					55    
#define PARA_STORAGE_RECORDSTATE	56    

#define PARA_PU_MANAGERSVR			57    
#define PARA_PU_DEVICEID			58    
#define PARA_STREAMCLIENT			59    
#define PARA_DATEFORMAT				60    
#define PARA_HTTPPORT				61    

#define PARA_CMOS_SCENE				62    
#define PARA_SMTP_INTO				63    
#define PARA_SMTP_ENABLE			64    
#define PARA_SENSORFLIP				65    

#define PRAM_WIFI_PARAM				66
#define PARA_WIFI_SEARCH_RESULT		67   

#define PARA_PRIVACYPROTECT			68
#define PARA_NTP					69
#define PARA_ALARTHRESHOLD			70
#define PARA_OSDALPHA				71
#define PARA_WORDOVERLAY			72
	
#define PARA_ALARMSERVER			73
#define PARA_DHCP_BACK				74
#define PARA_WIFIDHCP_BACK			75
#define PARA_DIAPHANEITY			76
#define PARA_PTZ_PROTOCOL			77
#define PARA_3D						78
#define PARA_DISK_USAGE				79
#define PARA_VIDEOPARA_SCHEDULE		80
#define PARA_ALARM_INPORT			81
#define PARA_ALARM_OUT				82
#define PARA_INPORT_SCHEDULE		83
#define PARA_OUTPORT_SCHEDULE		84
#define PARA_MOTION_SCHEDULE		85
#define PARA_VDOLOST_SCHEDULE		86
#define PARA_VDOLOST_LINKREC		87
#define PARA_MOTIONDEC_LINKREC		88
#define PARA_ALMINPORT_LINKREC		89
#define PARA_VDOLOST_LINKSNAP		90
#define PARA_MOTIONDEC_LINKSNAP		91
#define PARA_ALMINPORT_LINKSNAP		92
#define PARA_VDOLOST_LINKPTZ		93
#define PARA_ALMINPORT_LINKPTZ		94
#define PARA_VDOLOST_LINKSNDDIS		95
#define PARA_MOTIONDEC_LNKSNDDIS	96
#define PARA_ALMINPORT_LNKSNDDIS	97
#define PARA_ALMINPORT_LNKOUT		98
#define PARA_VDOLOST_LNKOUT			99
#define PARA_MOTIONDEC_LNKOUT		100
#define PARA_OUTPORT_DELAY			101
#define PARA_UPNP_ENABLE			102
#define PARA_SYSINFO_RESULT			103
#define PARA_DDNSCHANGED 			104	   
#define PARA_FUNCLIST				105	
#define PARA_OUTPORT_STATE			106
#define PARA_ZTEINFO				107
#define PARA_ONLINESTATE			108
#define PARA_DZINFO					109
#define PARA_COMSERVER				110
#define PARA_VENCTYPE				111
#define PARA_PTZAUTOPBACK			112
#define PARA_3GDEVICESTATUS			113
#define PARA_3GDIALOG				114
#define PARA_3GMESSAGE				115
#define PARA_HDCAMER				116
#define PARA_HXLISTENPORTINFO		117
#define PARA_3GTASKSCHEDULE			118
#define PARA_3GNOTIFY				119



// enum IDENTIFY {CLIENT=0,PROXY,CLIENT_PROXY};
typedef int							IDENTIFY;
#define CLIENT						0
#define PROXY						1
#define CLIENT_PROXY				2

//enum DECDATATYPE {T_AUDIO8,T_YUV420,T_YUV422};
typedef int							DECDATATYPE;
#define T_AUDIO8					0
#define T_YUV420					1
#define T_YUV422					2

typedef struct
{
    int     m_iPara[10];
    char    m_cPara[33];
}STR_Para;

//Templet time
/*typedef struct
{
	UINT8		m_u8StartHour;
	UINT8		m_u8StartMin;
	UINT8		m_u8StopHour;
	UINT8		m_u8StopMin;
}NVS_TEMPLETTIME,*PNVS_TEMPLETTIME;*/

//Schedle time
typedef struct
{
	unsigned short		iStartHour;
	unsigned short		iStartMin;
	unsigned short		iStopHour;
	unsigned short		iStopMin;
	unsigned short		iRecordMode; //iEnable;
}NVS_SCHEDTIME,*PNVS_SCHEDTIME;

typedef struct
{
	unsigned short 		m_u16Brightness;
	unsigned short 		m_u16Hue;
	unsigned short 		m_u16Contrast;
	unsigned short 		m_u16Saturation;
	/*
	UINT8		m_u8StartHour;
	UINT8		m_u8StartMin;
	UINT8		m_u8StopHour;
	UINT8		m_u8StopMin;
	*/
	NVS_SCHEDTIME strctTempletTime;
}STR_VideoParam;

typedef struct
{
    char 	cEncoder[16];		//NVS IP
    char 	cClientIP[16];		//Client IP
    int		iChannel;			//Channel Number
    int     iStreamNO;          //Stream type
    int 	iMode;			    //Network mode1TCP 2UDP3multicast
}LINKINFO, *PLINKINFO;

typedef struct
{
    int		        iCount;			            //Connect Count
    unsigned int  	uiID[MAX_ENCODER];		    //ID
}UIDLIST, *PUIDLIST;

typedef struct
{
    char		m_cHostName[32];    //NVS host name
    char		m_cEncoder[16];   	//NNS (IP)
    int         m_iRecvMode;    	//Network mode
    char     	m_cProxy[16];     	//Proxy (IP)
	char        m_cProID[32];       //ProductID
    int         m_iPort;        	//NVS port
    int         m_nvsType;          //NVS type(NVS_T or NVS_S)
}ENCODERINFO,*PENCODERINFO;

typedef struct
{
	int             m_iServerID;        //NVS ID,NetClient_Logon ֵ
	int 			m_iChannelNo;	    //Remote host to be connected video channel number (Begin from 0)
    char            m_cNetFile[255];    //Play the file on net, not used temporarily
	char		 	m_cRemoteIP[16];	//IP address of remote host
	int 			m_iNetMode;		    //Select net mode 1--TCP  2--UDP  3--Multicast
	int				m_iTimeout;		    //Timeout length for data receipt
	int 			m_iTTL;			    //TTL value when Multicast
    int             m_iBufferCount;     //Buffer number
    int             m_iDelayNum;        //Start to call play progress after which buffer is filled
    int             m_iDelayTime;       //Delay time(second), reserve
    int             m_iStreamNO;        //Stream type
	int				m_iFlag;			//0״¼ļ1¼ļ
	int				m_iPosition;		//0100λļλã-1жλ
	int				m_iSpeed;			//1248ļٶ
}CLIENTINFO;

//Version message structure, with which to transmit SDK version message
typedef struct
{
	unsigned short	m_ulMajorVersion;
	unsigned short	m_ulMinorVersion;
	unsigned short	m_ulBuilder;
	char*			m_cVerInfo;
}SDK_VERSION;

//OSD param
typedef struct
{
	unsigned char	ucCovTime;
	unsigned char 	ucCovWord;
	int             iCovYear;
	int             iCovMonth;
    int             iCovDay;
    int             iCovHour;
    int             iCovMinute;
    int             iCovSecond;
    unsigned char   ucPosition;
    char            cCovWord[32];
}OSD_PROPERTY;

//Hardware decode to show external data parameter
typedef struct
{
    int     m_iChannelNum;      //Decode card hardware channel number
	int     m_iVideoWidth;		//Video width
	int     m_iVideoHeight;		//Video height
	int     m_iFrameRate;		//Frame rate
	int     m_iDisPos;			//Video display position
    int     m_iAudioOut;        //whether to output audio
}DecoderParam;

typedef struct
{
    unsigned long nWidth;    //Video width, audio data is 0
    unsigned long nHeight;   //Video height, audio data is 0
    unsigned long nStamp;    //Time stamp(ms)
    unsigned long nType;     //Audio typeT_AUDIO8,T_YUV420
    unsigned long nFrameRate;//Frame rate
    unsigned long nReserved; //reserve
}FRAME_INFO;

// enum RAWFRAMETYPE
// {
//     VI_FRAME = 0,   //ƵI֡
//     VP_FRAME = 1,   //ƵP֡
//     AUDIO_FRAME = 5 //Ƶ֡
// };

typedef int						RAWFRAMETYPE;
#define VI_FRAME				0
#define VP_FRAME				1
#define AUDIO_FRAME				5

typedef struct
{
    unsigned long nWidth;    //Video width, audio data is 0
    unsigned long nHeight;   //Video height, audio data is 0
    unsigned long nStamp;    //Time stamp(ms)
    unsigned long nType;     //RAWFRAMETYPE
    unsigned long nEnCoder;  //Audio or Video encoder(Video,0:H263,1:H264, 2:MP4. Audio:AUDIO_ENCODER)
    unsigned long nFrameRate;//Frame rate
    unsigned long nReserved; //reserve
}RAWFRAME_INFO;

//typedef void (__stdcall *RECVDATA_NOTIFY)(unsigned char* _ucData,unsigned long _ulIP,int _iPort,int _iNetMode,int _iLen);
typedef void (__stdcall *RECVDATA_NOTIFY)(unsigned long _ulID,unsigned char* _ucData,int _iLen);
typedef void (__stdcall *LOGON_NOTIFY)(int _iLogonID/*char* _cIP*/,int _iLogonState);
typedef void (__stdcall *ALARM_NOTIFY)(int _iLogonID/*char* _cIP*/,int _iCh,void* _vContext,ALARMTYPE _iAlarmType);
typedef void (__stdcall *PARACHANGE_NOTIFY)(int _iLogonID/*char* _cIP*/,int _iCh,PARATYPE _iParaType,void* _strPara);
typedef void (__stdcall *TALK_NOTIFY)(char* _cIP,int _iServerResponse);
typedef void (__stdcall *PROUPGRADE_NOTIFY)(int _iLogonID/*char* _cIP*/,int _iServerState);
typedef void (__stdcall *WEBUPGRADE_NOTIFY)(int _iLogonID/*char* _cIP*/,int _iServerState);
typedef void (__stdcall *COMRECV_NOTIFY)(int _iLogonID/*char* _cIP*/, char *_buf, int _length,int _iComNo);

typedef void (__stdcall *DECYUV_NOTIFY)(unsigned long _ulID, unsigned char* _ucData, int _iSize, FRAME_INFO *_pFrameInfo, void* _pContext);
typedef void (__stdcall *RAWFRAME_NOTIFY)(unsigned long _ulID, unsigned char* _ucData, int _iSize, RAWFRAME_INFO *_pRawFrameInfo, void* _pContext);

//===========================================================================
//  storage  add 2007.6.13
//===========================================================================

#define MAX_DAYS 7
#define MAX_TIMESEGMENT 4
#define MAX_PAGE_SIZE   20

//Record type 1-Manual record2-Schedule record3-Alarm record
//enum RECORD_TYPE {RECORD_ALL=0xFF, RECORD_MANUAL=1, RECORD_TIME=2, RECORD_ALARM=3, RECORD_OTHER};
typedef int						RECORD_TYPE;
#define RECORD_ALL				0xFF
#define RECORD_MANUAL			1
#define RECORD_TIME				2
#define RECORD_ALARM			3
#define RECORD_OTHER			4

//Record state
// enum RECORD_STATE {REC_STOP=0, REC_MANUAL=1, REC_TIME=2, REC_ALARM=3};
typedef int						RECORD_STATE;
#define REC_STOP				0
#define	REC_MANUAL				1	
#define REC_TIME				2
#define REC_ALARM				3

//Audio encoder
// enum AUDIO_ENCODER
// {
//     G711_A              = 0x01,  /* 64kbps G.711 A, see RFC3551.txt  4.5.14 PCMA */
//     G711_U              = 0x02,  /* 64kbps G.711 U, see RFC3551.txt  4.5.14 PCMU */
//     ADPCM_DVI4          = 0x03,  /* 32kbps ADPCM(DVI4) */
// 
//     G726_24KBPS         = 0x05,  /* 24kbps G.726, see RFC3551.txt  4.5.4 G726-24 */
//     G726_32KBPS         = 0x06,  /* 32kbps G.726, see RFC3551.txt  4.5.4 G726-32 */
//     G726_40KBPS         = 0x07,  /* 40kbps G.726, see RFC3551.txt  4.5.4 G726-40 */
//     MPEG_LAYER2         = 0x0E,  /* Mpeg layer 2*/
// 
// 	AMR_NB				= 0x15,		
// 
//     ADPCM_IMA           = 0x23,  /* 32kbps ADPCM(IMA) */
//     MEDIA_G726_16KBPS   = 0x24,  /* G726 16kbps for ASF ... */
//     MEDIA_G726_24KBPS   = 0x25,  /* G726 24kbps for ASF ... */
//     MEDIA_G726_32KBPS   = 0x26,  /* G726 32kbps for ASF ... */
//     MEDIA_G726_40KBPS   = 0x27   /* G726 40kbps for ASF ... */
// };

typedef int						AUDIO_ENCODER;
#define G711_A					0x01
#define G711_U					0x02
#define ADPCM_DVI4				0x03
#define G726_24KBPS				0x05
#define G726_32KBPS				0x06
#define G726_40KBPS				0x07
#define	MPEG_LAYER2				0x0E
#define AMR_NB					0x15
#define ADPCM_IMA				0x23
#define MEDIA_G726_16KBPS		0x24
#define MEDIA_G726_24KBPS		0x25
#define MEDIA_G726_32KBPS		0x26
#define	MEDIA_G726_40KBPS		0x27

//Record rule
typedef struct
{
	int             iTaskRecord; 	/*Schedle record enabled 0-Enable 1-Disable*/
	int             iAlarmRecord; 	/*Alaum record enabled 0-Enable 1-Disable*/
	NVS_SCHEDTIME	struRecordSched[MAX_DAYS][MAX_TIMESEGMENT];
}NVS_CHAN_RECORD,*PNVS_CHAN_RECORD;

//Record mode param
typedef struct
{
    int  iPreRecord[MAX_CHANNEL_NUM];			/* Prerecord enabled: 0-Enable 1-Disable*/
    int  iPreRecordTime[MAX_CHANNEL_NUM]; 		/* Prerecord time 5-30sdefault 10s */
    int  iDelayTime[MAX_CHANNEL_NUM];			/* Delay time*/
	int  iDelayEnable[MAX_CHANNEL_NUM];			/*Delay enabled: 0-Enable 1-Disable*/
    char cExternName[10];	/* Record file extended name */
    int  iRecordTime; 	    /* Record time length */
    int  iRecPolicy;        /* Storage strategy */
    int  iFreeDisk;         /* Minimum free disk space */
	int  iFileSize;			/* File maximum space*/
}NVS_RECORD,*PNVS_RECORD;

//Record time parameter
typedef struct
{
	unsigned short iYear;   /* Year */
	unsigned short iMonth;  /* Month */
	unsigned short iDay;    /* Day */
	unsigned short iHour;   /* Hour */
	unsigned short iMinute; /* Minute */
	unsigned short iSecond; /* Second */
} NVS_FILE_TIME,*PNVS_FILE_TIME;

//Record File Property
typedef struct
{
	int             iType; 	        /* Record type 1-Manual record, 2-Schedule record, 3-Alarm record*/
	int 	        iChannel; 	    /* Record channel 0~channel defined channel number*/
	char 		    cFileName[250]; /* File name */
	NVS_FILE_TIME	struStartTime; 	/* File start time */
	NVS_FILE_TIME	struStoptime; 	/* File end time */
	int             iFileSize; 	    /* File size */
}NVS_FILE_DATA,*PNVS_FILE_DATA;

//Reserch parameter
typedef struct
{
	int          	iType; 	        /* Record type 0xFF-All, 1-Manual record, 2-Schedule record, 3-Alarm record*/
	int     	    iChannel; 	    /* Record channel 0xFF-All, 0~channel-defined channel number*/
	NVS_FILE_TIME	struStartTime; 	/* Start time of file */
	NVS_FILE_TIME	struStopTime; 	/* End time of file */
	int     	    iPageSize;	    /* Record number returned by each research*/
	int         	iPageNo;	    /* From which page to research */
    int             iFiletype;      /* File type, 0-All, 1-AVstream, 2-picture*/
	int				iDevType;		/* 豸ͣ0- 1-Ƶ 2- 0xff-ȫ*/
}NVS_FILE_QUERY, *PNVS_FILE_QUERY;

//Net storage device
typedef struct
{
    char cDeviceIP[16];
    char cStorePath[250];
    char cUsername[16];
    char cPassword[16];
    int  iState;
}NVS_NFS_DEV,*PNVS_NFS_DEV;

//Diskinfo
//disk manager
#define DISK_SATA_NUM	8
#define DISK_USB_NUM	4
#define	DISK_NFS_NUM	1

//enum DISK_STATUSTYPE{DISK_ZERO = 0,DISK_NOTFORMAT,DISK_FORMATED,DISK_CANUSE,DISK_READING};
typedef int					DISK_STATUSTYPE;
#define DISK_ZERO			0
#define DISK_NOTFORMAT		1
#define DISK_FORMATED		2
#define DISK_CANUSE			3
#define DISK_READING		4

/*typedef struct
{
    int  iTotal;        //total size
    int  iFree;         //free size
    int  iReserved;     //reserved
}NVS_DISKINFO, *PNVS_DISKINFO;*/

typedef struct
{
	unsigned int	m_u32TotalSpace; // ܴС
	unsigned int	m_u32FreeSpace;  // ʣռ
	unsigned short  m_u16PartNum;    //   14
	unsigned short  m_u16Status;     // ״̬ 0޴̣1δʽ2Ѹʽ3ѹأ4д
	unsigned short  m_u16Usage;      // ; 0¼1
	unsigned short	m_u16Reserve;	 //	
}NVS_DISKINFO, *PNVS_DISKINFO;

//Storage device info
/*typedef struct
{
    NVS_DISKINFO  usbDisk;  //usb disk information
    NVS_DISKINFO  nfsDisk;  //nfs disk information
    NVS_DISKINFO  ideDisk;  //ide disk information
}NVS_STORAGEDEV, *PNVS_STORAGEDEV;*/

typedef struct
{
	NVS_DISKINFO m_strctSATA[DISK_SATA_NUM];
	NVS_DISKINFO m_strctUSB[DISK_USB_NUM];
	NVS_DISKINFO m_strctNFS[DISK_NFS_NUM];
}NVS_STORAGEDEV, *PNVS_STORAGEDEV;

//enum SMTP_AUTHTYPE {AUTH_OFF=0,AUTH_PLAIN,AUTH_CRAM_MD5,AUTH_DIGEST_MD5,AUTH_GSSAPI,AUTH_EXTERNAL,AUTH_LOGIN,AUTH_NTLM,SMTP_AUTHTYPE_LAST};
typedef int					SMTP_AUTHTYPE;
#define AUTH_OFF			0
#define AUTH_PLAIN			1
#define AUTH_CRAM_MD5		2
#define AUTH_DIGEST_MD5		3
#define AUTH_GSSAPI			4
#define AUTH_EXTERNAL		5
#define AUTH_LOGIN			6
#define AUTH_NTLM			7
#define SMTP_AUTHTYPE_LAST	8

//enum SCENE_TYPE {AUTO=0, SCENE1,SCENE2,SCENE3,SCENE4,SCENE5,SCENE6,SCENE7,SCENE8,SCENE9,SCENE10,SCENE11,SCENE_TYPE_LAST};
typedef	int					SCENE_TYPE;
#define AUTO				0
#define SCENE1				1
#define SCENE2				2
#define SCENE3				3
#define SCENE4				4
#define SCENE5				5
#define SCENE6				6
#define SCENE7				7
#define SCENE8				8
#define SCENE9				9
#define SCENE10				10
#define SCENE11				11
#define SCENE_TYPE_LAST		12


//SMTP alarm info
typedef struct
{
    char            cSmtpServer[32];    //smtp server
    unsigned short  wdSmtpPort;         //smtp server port
    char            cEmailAccount[32];  //mail account
    char            cEmailPassword[32];  //mail password
    int				iAuthtype;           //authtype
    char            cEmailAddress[32];  //mailbox address
    char            cMailSubject[32];   //mail subject
}SMTP_INFO,*PSMTP_INFO;
//---------------------------------------------------------------------------

typedef struct
{
    char cESSID[33];			//ESSID
    char cEncryption[16];		//wifi encrypttion flag; 0 no encryption1 digital encryption
}WIFI_INFO, *PWIFI_INFO;

typedef struct
{
	char    m_cDDNSUserName[32];
    char    m_cDDNSPwd[32];
	char    m_cDDNSNvsName[32];
	char    m_cDDNSDomain[32];
	int     m_iDDNSPort;
	int     m_iDDNSEnable;
}DDNS_INFO, *PDDNS_INFO;

typedef struct
{
	char	cESSID[33];			//ESSID
	char	cWifiSvrIP[16];		//wifiIP
	char	cWifiMask[16];			//wifi mask
	char	cWifiGateway[16];		//wifi gateway
	char	cWifiDNS[16];			//wifi DNS
	char	cWifiKeyType[16];		//wifi KeyTypeHexASCII
	char	cWifiPassword[32];		//wifi password
	char	cEncryption[16];		//wifi encrypttion flag; NULL no encryption"WEP" encryption
    char	cWifiKeyNum[2];        //wifi KeyNum (1,2,3,4)
    int		iPwdFormat;
	int		iHaveCard;
	int		iCardOnline;
}NVS_WIFI_PARAM, *PNVS_WIFI_PARAM;

typedef struct NVS_IPAndID
{
	char *m_pIP;
	char *m_pID;
	unsigned int *m_puiLogonID;
}*pNVS_IPAndID;

typedef struct			//ƵͨϢ
{
	char    m_cParam1[64];
	char    m_cParam2[64];
	char    m_cParam3[64];
	char    m_cParam4[64];
	char    m_cParam5[64];
	char    m_cParam6[64];
	char    m_cParam7[64];
	char    m_cParam8[64];
	char    m_cParam9[64];
	char    m_cParam10[64];
	char    m_cParam11[64];
	char    m_cParam12[64];
	char    m_cParam13[64];
	char    m_cParam14[64];
	char    m_cParam15[64];
	char    m_cParam16[64];
	char    m_cParam17[64];
	char    m_cParam18[64];
	char    m_cParam19[64];
	char    m_cParam20[64];
}DZ_INFO_PARAM, *PDZ_INFO_PARAM;
#endif

